
package de.ivu.elect.presentation.person;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.person.boundary.BerufConversationStore;
import de.ivu.elect.business.person.boundary.BerufExtendedDAO;
import de.ivu.elect.business.person.boundary.BerufEdit;
import de.ivu.elect.business.person.entity.Beruf;
import de.ivu.elect.business.person.entity.BerufMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractBerufEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractBerufEditNoScopeView.VIEW_ID, useCase = UseCasePermission.BERUF_EDIT)
public abstract class AbstractBerufEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<Beruf>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "berufEditView";

  public static final String VIEW_ID = "/person/beruf-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/person/beruf-search.xhtml";

  @Inject
  protected transient BerufExtendedDAO extendedDAO;

  @Inject
  protected transient BerufEdit edit;

  @Inject
  @ConversationGroup(BerufConversationStore.class)
  protected transient BerufConversationStore conversationStore;

  @Inject
  protected transient BerufMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient BerufEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public Beruf getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(Beruf entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.BERUF_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(Beruf entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.BERUF_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.BERUF_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.BERUF_EDIT)
  @Override
  public String save() {
    Beruf entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Beruf entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    Beruf entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(Beruf entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.BERUF_EDIT);
  }
  
  @Redirect
  public String edit(Beruf entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class BerufEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<Beruf,   de.ivu.elect.business.person.entity.BerufPK  > {

    private static final long serialVersionUID = 1L;
  }
}
